<?php

# web site to show the status of server/xaseco  process
# it should be useful for server hosters with linux server and more than one tmf server
# this scrip need the log files created by the linux start/stop/restart shell scripts
# it will read it's informations and convert it to this page
# the running xaseco version is displayed too, same with actual releases by Xymph.
# if your version is not uptodate,  the version will be displayed in red color
# the name correspond to the shell script name "SAMPLE"
# state will be displayed as "running", "stopped" and "restarted" in green, red and yellow color
# only the last check will be displayed. depending on the cronjob or manual checking time
# made by nouseforname. thanks to Xymph
#=======================================================================================
#=========================== configure to your needs ====================================== 

# path to log files created by shell scripts, keep empty if same folder
$path = "";
# postfix of the log files
$postfix = "_status.log";
# your count of servers using status shell
$servercount = 2;

#=======================================================================================
#============================ don't change below here =====================================
#=======================================================================================
// take care the log file name and path
$timestamp = time();
$date = date('Y-m-d',$timestamp);
if ($path) {
	$slash = "/";
	}
$file = "$path$slash$date$postfix"; 
$count = $servercount * 2;

	// get actual xaseco version, thanks to Xymph :)
	$xaseco_ver = file('http://www.gamers.org/tmn/version.txt');
	foreach ($xaseco_ver as $ver) {
		$newversion = trim($ver);
		}
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="X-UA-Compatible" content="IE=EmulateIE7" />
<title>Server status page</title>
<meta name="author" content="Nouseforname"/>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<style type="text/css">
<!--
body {
	background: #989890;
         color: #303030;
         margin: 50px auto;
         padding: 0px;
         font-family: Tahoma, Verdana, Helvetica,  Arial, sans-serif;
         text-align: center;
         font-size: 14px;
}

#content {
		background: #a9a9a2;
		width: 600px;	
		border: 2px solid #000;		
		text-align: center;
		margin: 0px auto;
		padding: 20px 0px 5px 0px ;
		height: auto;
}

a:link, a:visited, a:active   {
        text-decoration: underline;
        color: #000;
}

a:hover {
	color: #ff0;
	text-decoration: none;
}
table {
	width: 90%;
	border: 1px dotted #000;
	text-align: center;
	margin: 0px auto ;
	padding: 0px;
}
	
th {
	color: #ffffee;
}

.headline {
	background: #555555;
	color: #ffffff;
	font-weight: bold;
}

.links {
	margin:  5px;
	padding: 0px;
	font-size: 8px;
	font-weight: bold;
}

p {
	margin: 0px;
	padding: 0px;
}
-->
</style>
</head>
<body>
	<div id="content">
		<table cellspacing="1px" cellpadding="1px">
			<tr class="headline" >
				<th colspan="4" >Server Status</th>
			</tr>
			<tr class="headline">
				<td>Name</td><td>App</td><td>State</td><td>Last Check</td>
			</tr>
<?php		
				// check for log file
				if(file_exists($file)) {
					$content = file($file);
						// don't read the whole log
						for($i = 0; $i < $count; $i++) {
							// get last check only
							$newcontent = array_reverse($content);
							// seperate each line into single variables
							$entry = explode(" ",$newcontent[$i]); 
								$time = trim($entry[0]);
								$app = trim($entry[1]);
								$version = trim($entry[2]);
								$state = trim($entry[3]);
								// cut last 3 digits from time string
								$last_check = substr($time, 0, 5);
								// make  delete array
								$apps = array(dedi, xaseco, " ");
								$who_ = str_replace($apps, "", $app);
									// dedi or xaseco?
									if (ereg("xaseco", $app))  {
										$tablecolor = "#999992";
										if(ereg("running", $state)) {
											// compare running versions with actual one
											if ( $newversion  == $version ) {
												$tcol = "#fff";
												}
												else {
													$tcol = "#f00";
													}
											$serv = "<td style=\"color: $tcol;\">XAseco v$version</td>";
											}
											else {
												$tcol = "#fff";
												$serv = "<td style=\"color: $tcol;\">XAseco</td>";
												}
										}
									 else {
										$tablecolor = "#afaf99";
										$serv = "<td style=\"color: #116\">Dedi</td>";
										}
							// output			
							echo "\t\t\t<tr bgcolor=\"$tablecolor\">\n";	
							echo "\t\t\t\t<td style=\"font-weight: bold;\">$who_</td>";
							echo $serv;
							if (ereg("running", $state)) {
								$statecol = "#080";
								}
								elseif (ereg("restarted", $state)){
								$statecol = "#ff0";
								}
								else {
									$statecol = "#f00";
									}		
							echo "<td style=\"color: $statecol;\">$state...</td>";
							echo "<td>$last_check h</td>\n";
							echo "\t\t\t</tr>\n";			
					}
				}
				else
				{
					echo"\t\t\t<tr><td>Log file not found!!!</td></tr>\n";
				}
			echo "\t\t</table>\n";
			echo "\t\t<div class=\"links\">
			<a href=\"http://www.gamers.org/tmn\" target=\"_blank\" onfocus=\"this.blur()\" onclick=\"this.blur()\">Get actual XAseco v$newversion !!!</a>\n\t\t</div>";
?>	
	</div>
	<div class="links" >
	<p>&copy; 2009 by <a href="http://tmf.game-host.org" target="_blank" onfocus="this.blur()" onclick="this.blur()">Nouseforname</a></p>
	</div>
</body>
</html>